function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var ReactDropdown = _interopDefault(require('react-dropdown'));
require('react-dropdown/style.css');
var reactHookForm = require('react-hook-form');

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

var styles = {"test":"_3ybTi"};

var Dropdown = function Dropdown(_ref) {
  var options = _ref.options,
      isValid = _ref.isValid;

  var _React$useState = React.useState(options[0]),
      value = _React$useState[0],
      setValue = _React$useState[1];

  function handleChange(value) {
    setValue(value);
    isValid(value.value);
  }

  return React.createElement("div", null, React.createElement(ReactDropdown, {
    onChange: function onChange(selected) {
      return handleChange(selected);
    },
    options: options,
    value: value
  }));
};

var Input = function Input(_ref) {
  var name = _ref.name,
      _isValid = _ref.isValid,
      className = _ref.className,
      errorClassName = _ref.errorClassName,
      _onChange = _ref.onChange;

  var _useForm = reactHookForm.useForm({
    mode: 'onBlur'
  }),
      register = _useForm.register,
      errors = _useForm.errors;

  return React.createElement(React.Fragment, null, React.createElement("input", {
    onChange: function onChange(event) {
      return _onChange(event, name);
    },
    className: className,
    type: 'text',
    name: name,
    ref: register({
      validate: {
        isValid: function isValid(value) {
          return _isValid(value);
        }
      },
      required: 'Ez a mező kötelező',
      minLength: {
        value: 2,
        message: 'A bevitt szöveg túl rövid...'
      }
    })
  }), errors[name] && React.createElement("p", {
    className: errorClassName
  }, errors[name].message));
};

var renderInputs = function renderInputs(_ref) {
  var type = _ref.type,
      name = _ref.name,
      validate = _ref.validate,
      className = _ref.className,
      errorClassName = _ref.errorClassName,
      handleInputvalues = _ref.handleInputvalues,
      dropDownOptions = _ref.dropDownOptions,
      labelClassName = _ref.labelClassName,
      label = _ref.label,
      _onClick = _ref.onClick,
      buttonLabel = _ref.buttonLabel,
      inputClassName = _ref.inputClassName;

  if (type === 'input') {
    return React.createElement(React.Fragment, null, React.createElement("label", {
      className: labelClassName
    }, label), React.createElement(Input, {
      className: className,
      errorClassName: errorClassName,
      isValid: function isValid(value) {
        return validate(value);
      },
      name: name,
      onChange: function onChange(event, name) {
        return handleInputvalues(event, name);
      }
    }));
  } else if (type === 'dropdown') {
    return React.createElement(Dropdown, {
      isValid: function isValid(value) {
        return validate(value);
      },
      options: dropDownOptions
    });
  } else if (type === 'textarea') {
    return React.createElement(React.Fragment, null, React.createElement("label", {
      className: labelClassName
    }, label), React.createElement(Input, {
      isValid: function isValid(value) {
        return validate(value);
      },
      className: className + " " + inputClassName,
      name: name,
      errorClassName: errorClassName,
      onChange: function onChange(event, name) {
        return handleInputvalues(event, name);
      }
    }));
  } else if (type === 'button') {
    return React.createElement(React.Fragment, null, React.createElement("p", null, label), React.createElement("button", {
      className: inputClassName,
      type: 'button',
      onClick: function onClick() {
        return _onClick();
      }
    }, buttonLabel));
  }

  return undefined;
};

var ReactLogicForm = function ReactLogicForm(_ref) {
  var inputs = _ref.inputs;

  var _React$useState = React.useState(1),
      currentLevel = _React$useState[0],
      setCurrentLevel = _React$useState[1];

  var _React$useState2 = React.useState({}),
      inputValues = _React$useState2[0],
      setInputValues = _React$useState2[1];

  function validate(value) {
    var result = value.length > 1;

    if (result) {
      if (currentLevel < inputs.inputs.length) {
        setCurrentLevel(function (currentValue) {
          return currentValue + 1;
        });
      }
    }
  }

  function _handleInputvalues(event, name) {
    var _extends2;

    setInputValues(_extends({}, inputValues, (_extends2 = {}, _extends2[name] = event.target.value, _extends2)));
  }

  function handleSubmit() {
    inputs.config.onSubmit(inputValues);
  }

  return React.createElement("div", {
    className: inputs.config.baseClassName
  }, Array.from(new Array(currentLevel)).map(function (_, index) {
    return inputs.inputs[index].inputs.map(function (currentInput) {
      return React.createElement("div", {
        className: styles.oneInput,
        key: currentInput.key
      }, renderInputs({
        buttonLabel: currentInput.buttonLabel,
        inputClassName: currentInput.inputClassName,
        labelClassName: inputs.config.labelClassName,
        label: currentInput.label,
        name: currentInput.name,
        type: currentInput.inputType,
        validate: validate,
        className: inputs.config.className,
        onClick: currentInput.onClick ? currentInput.onClick : function () {
          return setCurrentLevel(function (currentValue) {
            return currentValue + 1;
          });
        },
        errorClassName: inputs.config.errorClassName,
        dropDownOptions: currentInput.dropDownOptions ? currentInput.dropDownOptions : [],
        handleInputvalues: function handleInputvalues(event, name) {
          return _handleInputvalues(event, name);
        }
      }));
    });
  }), currentLevel === inputs.inputs.length && React.createElement("button", {
    className: inputs.config.submitClass,
    type: 'button',
    onClick: function onClick() {
      return handleSubmit();
    }
  }, inputs.config.submitButtonLabel));
};

exports.ReactLogicForm = ReactLogicForm;
//# sourceMappingURL=index.js.map
